#ifndef SETTINGS_H
#define SETTINGS_H


/***************************************************
	GenericSettings.h

	2002 mmu_man
	from Deskscope:
	2000 Shamyl Zakariya
***************************************************/
#include "common.h"

/****************************************
	Simple class for getting and setting prefs.
	Instantiating will open up settings file
	Destroying will write settings plus any changes
	back into the file.

	Settings file won't be updated until Settings
	destructor is called. Doens't matter if it's allocated off
	heap or stack. I recommend stack, though, to keep likelyhood
	of race conditions down.
	
	File is defined in common.h as SETTINGS_FILE

****************************************/


class Settings
{
	protected:
		BFile _settingsFile;
//		BPath _appPath;

		BMessage _settingsMessage;

#define CONF_ADDPROP(_type, _msgt, _cast, _byref, _name, _strname, _default) \
		_type _conf##_name;
#include "SettingsProps.h"
#undef CONF_ADDPROP
		

			
		BMessage openSettingsFile();
		void closeSettingsFile();
	
	public:
		Settings();
		~Settings();


#define CONF_ADDPROP(_type, _msgt, _cast, _byref, _name, _strname, _default) \
		void Set##_name(_type value);\
		_type _name();

#include "SettingsProps.h"
#undef CONF_ADDPROP
};


#define AR_APP_PATH "ar:app_path"

#endif
